#!/usr/bin/perl

$P = "dbamon_magnify_menu.pl";
require "cgi_handlers.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

# General parms required
$date          = `date`;
$keyStart      = 1000;

$maxrows       = 500;

$| = 1;
$readfile      = "/tmp/dbamon_text.txt";

$data_source = "dbi:mysql";
$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  $passwd = "dbamon";
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n"; 
}

#------------------------------------------------------------------------------
sub menuOracleNT
#------------------------------------------------------------------------------
{
  print "
  <h3>orantstat 'Display' Commands</h3>
  <table border=0>
  <tr bgcolor=slate>
     <th>orastat Option<th>Description
     <th>orastat Option<th>Description
  <tr>
      <td width=5% align=center><a   href='/cgi-bin/dbamon_magnify_run.pl?-,$mode,$instnum,$ck,$in,$dbms'><b>-  </b></a><td width=30% nowrap><b>Instance Status</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ar,$mode,$instnum,$ck,$in,$dbms'><b>-ar</b></a><td width=30% nowrap><b>Current Activity Rate</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-df,$mode,$instnum,$ck,$in,$dbms'><b>-df</b></a><td width=30% nowrap><b>Datafiles</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ts,$mode,$instnum,$ck,$in,$dbms'><b>-ts</b></a><td width=30% nowrap><b>Tablespaces</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-c,$mode,$instnum,$ck,$in,$dbms'><b>-c</b></a><td width=30% nowrap><b>View init.ora File</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-cp,$mode,$instnum,$ck,$in,$dbms'><b>-cp</b></a><td width=30% nowrap><b>In Effect Parameters (from v\$parameter)</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-m,$mode,$instnum,$ck,$in,$dbms'><b>-m</b></a><td width=30% nowrap><b>Alert Log (Last 20 Lines)</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ma,$mode,$instnum,$ck,$in,$dbms'><b>-ma</b></a><td width=30% nowrap><b>Alert Log (Entire File)</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-pd,$mode,$instnum,$ck,$in,$dbms'><b>-pd</b></a><td width=30% nowrap><b>Performance - Hit Ratios</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-pi,$mode,$instnum,$ck,$in,$dbms'><b>-pi</b></a><td width=30% nowrap><b>Performance - I/O</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ta,$mode,$instnum,$ck,$in,$dbms'><b>-ta</b></a><td width=30% nowrap><b>List All Tables (Slow)</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-in,$mode,$instnum,$ck,$in,$dbms'><b>-in</b></a><td width=30% nowrap><b>List All Indices (Slow)</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-se,$mode,$instnum,$ck,$in,$dbms'><b>-se</b></a><td width=30% nowrap><b>Sessions</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-sw,$mode,$instnum,$ck,$in,$dbms'><b>-sw</b></a><td width=30% nowrap><b>Session Waits</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ra,$mode,$instnum,$ck,$in,$dbms'><b>-ra</b></a><td width=30% nowrap><b>Rollback Statistics</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-rb,$mode,$instnum,$ck,$in,$dbms'><b>-rb</b></a><td width=30% nowrap><b>Rollback Status</b>
  </table>
  <hr>
  <h3>orantadmin 'Alter' Commands</h3> 
  <table border=0>
  <tr bgcolor=slate>
     <th>oraadmin Option<th>Description
     <th>oraadmin Option<th>Description
  <tr>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-start,$mode,$instnum,$ck,$in,$dbms'><b>-start</b></a><td width=30% nowrap><b>Start Oracle (startup)</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-stop,$mode,$instnum,$ck,$in,$dbms'><b>-stop</b></a><td width=30% nowrap><b>Shutdown Oracle (shutdown immediate)</b>
  <tr bgcolor=lightgrey>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-bounce,$mode,$instnum,$ck,$in,$dbms'><b>-bounce</b></a><td width=30% nowrap><b>Shutdown Oracle Followed By Start Oracle</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-switch,$mode,$instnum,$ck,$in,$dbms'><b>-switch</b></a><td width=30% nowrap><b>Switch REDO Logs</b>
  <tr>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-arclog_on,$mode,$instnum,$ck,$in,$dbms'><b>-arclog_on</b></a><td width=30%><b>Shutdown Immediate; Startup Mount; Alter Database Archivelog;</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-arclog_off,$mode,$instnum,$ck,$in,$dbms'><b>-arclog_off</b></a><td width=30%><b>Shutdown Immediate; Startup Mount; Alter Database Noarchivelog;</b>
  <tr bgcolor=lightgrey>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-restrictenable,$mode,$instnum,$ck,$in,$dbms'><b>-restrictenable</b></a><td width=30% nowrap><b>Enable Restricted Session Mode</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-restrictdisable,$mode,$instnum,$ck,$in,$dbms'><b>-restrictdisable</b></a><td width=30% nowrap><b>Disable Restricted Sesion Mode</b>
  </table>
  ";
}

#------------------------------------------------------------------------------
sub menuOracleUX
#------------------------------------------------------------------------------
{
  print "
  <h3>orastat 'Display' Commands</h3>
  <table border=0>
  <tr bgcolor=slate>
     <th>orastat Option<th>Description
     <th>orastat Option<th>Description
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-,$mode,$instnum,$ck,$in'><b>-  </b></a><td width=30% nowrap><b>Instance Status</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ar,$mode,$instnum,$ck,$in'><b>-ar</b></a><td width=30% nowrap><b>Current Activity Rate (Slow)</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-c,$mode,$instnum,$ck,$in'><b>-c </b></a><td width=30% nowrap><b>View init.ora file</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-cp,$mode,$instnum,$ck,$in'><b>-cp</b></a><td width=30% nowrap><b>Oracle Parameters In-Effect</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-er,$mode,$instnum,$ck,$in'><b>-er</b></a><td width=30% nowrap><b>Display DBA_ERRORS</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ba,$mode,$instnum,$ck,$in'><b>-ba</b></a><td width=30% nowrap><b>View DBAMON.BACKUP_AGE Table</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-m,$mode,$instnum,$ck,$in'><b>-m </b></a><td width=30% nowrap><b>Alert Log - Last 20 Lines</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ma,$mode,$instnum,$ck,$in'><b>-ma</b></a><td width=30% nowrap><b>Alert Log - All</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-df,$mode,$instnum,$ck,$in'><b>-df</b></a><td width=30% nowrap><b>Datafiles</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ts,$mode,$instnum,$ck,$in'><b>-ts</b></a><td width=30% nowrap><b>Tablespaces</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-l,$mode,$instnum,$ck,$in'><b>-l </b></a><td width=30% nowrap><b>Archive Log Status</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ad,$mode,$instnum,$ck,$in'><b>-ad</b></a><td width=30% nowrap><b>Archive Destination Status</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-sg,$mode,$instnum,$ck,$in'><b>-sg</b></a><td width=30% nowrap><b>SGA Usage</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-st,$mode,$instnum,$ck,$in'><b>-st</b></a><td width=30% nowrap><b>System Statistics</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-se,$mode,$instnum,$ck,$in'><b>-se</b></a><td width=30% nowrap><b>Sessions</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-sw,$mode,$instnum,$ck,$in'><b>-sw</b></a><td width=30% nowrap><b>Session Waits</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-sc,$mode,$instnum,$ck,$in'><b>-sc</b></a><td width=30% nowrap><b>Sessions - Resource Consumption (Slow)</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-sd,$mode,$instnum,$ck,$in'><b>-sd</b></a><td width=30% nowrap><b>Session Details (Slow)</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-pd,$mode,$instnum,$ck,$in'><b>-pd</b></a><td width=30% nowrap><b>Performance - Hit Ratios</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-pi,$mode,$instnum,$ck,$in'><b>-pi</b></a><td width=30% nowrap><b>Performance - I/O</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ta,$mode,$instnum,$ck,$in'><b>-ta</b></a><td width=30% nowrap><b>List All Tables (Slow)</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-in,$mode,$instnum,$ck,$in'><b>-in</b></a><td width=30% nowrap><b>List All Indices (Slow)</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ub,$mode,$instnum,$ck,$in'><b>-ub</b></a><td width=30% nowrap><b>Total Bytes of Data - By Schema (Slow)</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ut,$mode,$instnum,$ck,$in'><b>-ut</b></a><td width=30% nowrap><b>Total Bytes of Data - By Schema and Tablespace (Slow)</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ra,$mode,$instnum,$ck,$in'><b>-ra</b></a><td width=30% nowrap><b>Rollback Statistics</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-rb,$mode,$instnum,$ck,$in'><b>-rb</b></a><td width=30% nowrap><b>Rollback Status</b>
  <tr bgcolor=lightgrey>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-fs,$mode,$instnum,$ck,$in'><b>-fs</b></a><td width=30% nowrap><b>Freespace By Datafile</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-us,$mode,$instnum,$ck,$in'><b>-us</b></a><td width=30% nowrap><b>User Status</b>
  <tr>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-lo,$mode,$instnum,$ck,$in'><b>-lo</b></a><td width=30% nowrap><b>Table Locks</b>
      <td width=5% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-ls,$mode,$instnum,$ck,$in'><b>-ls</b></a><td width=30% nowrap><b>Listener Status</b>
  </table>

  <hr>
  <h3>oraadmin 'Alter' Commands</h3> 
  <table border=0>
  <tr bgcolor=slate>
     <th>oraadmin Option<th>Description
     <th>oraadmin Option<th>Description
  <tr>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-start,$mode,$instnum,$ck,$in'><b>-start</b></a><td width=30% nowrap><b>Start Oracle (startup)</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-stop,$mode,$instnum,$ck,$in'><b>-stop</b></a><td width=30% nowrap><b>Shutdown Oracle (shutdown immediate)</b>
  <tr bgcolor=lightgrey>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-bounce,$mode,$instnum,$ck,$in'><b>-bounce</b></a><td width=30% nowrap><b>Shutdown Oracle Followed By Start Oracle</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-switch,$mode,$instnum,$ck,$in'><b>-switch</b></a><td width=30% nowrap><b>Switch REDO Logs</b>
  <tr>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-restrictenable,$mode,$instnum,$ck,$in'><b>-restrictenable</b></a><td width=30% nowrap><b>Enable Restricted Session Mode</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-restrictdisable,$mode,$instnum,$ck,$in'><b>-restrictdisable</b></a><td width=30% nowrap><b>Disable Restricted Sesion Mode</b>

  <tr bgcolor=lightgrey>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-arclog_on,$mode,$instnum,$ck,$in'><b>-arclog_on</b></a><td width=30%><b>Shutdown Immediate; Startup Mount; Alter Database Archivelog</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-arclog_off,$mode,$instnum,$ck,$in'><b>-arclog_off</b></a><td width=30%><b>Shutdown Immediate; Startup Mount; Alter Database Noarchivelog</b>
  <tr>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-coal_temp,$mode,$instnum,$ck,$in'><b>-coal_temp</b></a><td width=30%><b>Coalesce TEMP Tablespace(s)</b>
      <td nowrap width=10% align=center><a href='/cgi-bin/dbamon_magnify_run.pl?-listbounce,$mode,$instnum,$ck,$in'><b>-listbounce</b></a><td width=30% nowrap><b>Stop/Start The Listener</b>
  </table>";

}

#------------------------------------------------------------------------------
#
# Main  
#
#------------------------------------------------------------------------------

@words = split(/,/,@ARGV[0]);
$mode    = @words[0];
$instnum = @words[1];
$ck      = @words[2];
$instance= @words[3];
$dbms    = @words[4];

$dbms = "OracleUX" if $dbms eq "";

$in = $instance;

chop($host = `hostname`);
chop($dbamonid = `ls -l /opt/dbamon/adm/dbamonrc | awk '{ print \$3 }'`);

print "Content-type: text/html\n\n
<title>DBAmon One Instance 'Magnify'</title>
<body bgcolor=white link=darkblue vlink=darkblue><font face=verdana>
<table width=700><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=700>
<tr bgcolor=wheat><td><font face=verdana size=5>
    <center><img src='/dbamon/img/dbamon_magnif.gif'> $dbms 'Magnify' Menu - Instance: $instance</center>
</table>
<hr>";

if ($dbms eq "OracleNT")
{
  &menuOracleNT;
}
else
{
  &menuOracleUX;
}

print "<hr>Click <b>Back</b> to return to the DBAmon Instance Summary";

exit 0;
