# -----------------------------------------------------------------------------
sub sqlBkup
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  &logit("Starting", $thishost);

  #---- Local-ize vars
  my $backup_method_alternate = ""; 
  my $dbchk = ""; 
  my $zage = ""; 
  my $msg = ""; 
  my $z = ""; 
  my $backup_details = ""; 
  my $zd = ""; 
  my $zt = ""; 
  my $zts = ""; 
  my $bck_msg = ""; 
  my $bckcolor = ""; 
  my $bcksev = ""; 
  my $bckdays_report = ""; 
  my $z_mtime = -99;
  my $z_agesecs = -99;
  my $bck_full_events = ""; 

  ##print "up=$up[$thishost] title=$title[$thishost]\n"; 
  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($backup_age[$thishost] eq "" || $backup_age[$thishost] eq "N")
  {
    logit("Backup Aging not requested for this instance",$thishost);
    return 0;
  }

  #---- Backup_Age "BIAS" logic - START
  $ba_bias_file = "/opt/dbamon/adm/ba_bias_MSSQL.txt";
  if (-e "$ba_bias_file")
  {
    &logit("sqlBkup.pl | Found ba_bias_file=$ba_bias_file",$thishost);
    chop($ba_bias = `cat $ba_bias_file | grep -v '^#' | head -1`);
    if ($ba_bias > 0)
    {
      $backup_age[$thishost] = $backup_age[$thishost] * $ba_bias;
      &logit("sqlBkup.pl | Backup bias value ba_bias=$ba_bias is valid - Updated backup_age[$thishost]=$backup_age[$thishost]",$thishost);
    }
  }
  #---- Backup_Age "BIAS" logic - END

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    return;
  }

  if ($use_repository eq "Y")
  {
    $rc = &baICheck($thishost);
    if ($rc > 0)
    {
      $bainhibit[$thishost] = 1;
      $bckhours_c[$thishost] = "black";
      $bckhours[$thishost]   = "(I)";
      $msg = sprintf("Backup Age Checking Inhibited - Start: %s End: %s Created: %s User: %s Reason: %s",$bai_sts,$bai_ets,$bai_ts,$bai_user,$bai_reason);
      &logit($msg,$thishost);
      return 0 ;
    }
  }
  else
  {
    $msg = sprintf("Backup Aging Inhibit not possible because dbamonrc Use_Oracle: ne Y");
    &logit($msg,$thishost);
  }

  #---- 5.44.B - Remove all of this and just use probeout_file. 
  ## #---- If the SQLUP PROBEOUT file exists and was updated within the last hour, then use it. 
  ## #----   else, just do it the old (slow) way
  ## if (-e "$probeout_sqlup_file[$thishost]") 
  ## {
  ##   $z_mtime   = ( stat "$probeout_sqlup_file[$thishost]" ) [9];
  ##   $z_agesecs = time - $z_mtime;
  ## }
  ## else
  ## {
  ##   $z_agesecs = -1; 
  ## }

  ## if ($z_agesecs != -1 && $zage_secs < 7200) 
  ## {
  ##   &logit("Using PROBEOUT file ($probeout_sqlup_file[$thishost]) Instead of PROBING",$thishost);
  ##   use File::Copy;
  ##   copy("$probeout_sqlup_file[$thishost]", "$tmpfl3");
  ## }
  ## else
  ## {
  ##   &logit("PROBING for bkup data",$thishost);
  ##   &remsh("$perlpath[$thishost] $probe[$thishost] bkup $run_surgery[$thishost]",$tmpfl3,$thishost);
  ## }
  ## &probeLog; 

  $maxts = "";
  $bckhours_c[$thishost] = "lightgreen";
  my $finalage = -999;

  &logDetails($thishost,"<br><a name='sqlBkup'> <h3>MSSQL Database Backups</h3>");

  &logDetails($thishost,"<h5>DB's: msdb, master plus all user DBs Are Being Tracked For Backup_Age</h5>");

  &logDetails($thishost,"$f_s Additionally:
<li>Only DB's: ($backup_dbs[$thishost]) ARE being checked (if <b>Backup_Check_DBs:</b> was specified)<br>
<li>DB's: ($backup_nocheck_dbs[$thishost]) will be EXCLUDED from this check (if <b>Backup_NoCheck_DBs:</b> was specified)<br>
<p>");


  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>$f_s
    <th>$f_s Database<br>Name
    <th>$f_s Monitoring <br>Threshold<br>(Hours)
    <th>$f_s Age Of<br>Most Recent<br>Full/Incr.<br>Backup (Hours)
    <th>$f_s Most Recent<br>Full/Incr.<br>Backup Timestamp
    <th>$f_s Age of<br>Most Recent<br>Full Backup<br>(Days)
    <th>$f_s Message
  ");

  $delflag = 0;
  $backup_details = ""; 
  $sqlBkupTLogStack[$thishost] = ""; 

  $lstmeth = "";

  my $max_age = 0; 

  undef %events_811;
  undef $alltext_811;

  open(PROBEOUT, "$probeout_file[$thishost]"  ) || &error_msg("Cannot open input $probeout_file[$thishost] - $!");
  while(<PROBEOUT>)
  {
    &parse;
    ##print "F1=$F1 F2=$F2 F3=$F3\n";

    $mssql_backup_job_logic = 0;

    #---- Backup detail report data
    #---- BckDet: <xx> WSS_Content_Frontier I 2007/11/14-21:18:41 15
    if ($F1 eq "BckDet:")
    {
      $backup_details .= substr($F0,8); 
      next;
    }

    #---- dbamon_mssql.pl DBS_FULL_LOGGING_NO_TLOG_BACKUP: 5 model,ReportServer$MSSQL2,bbtest1ab,bbtest2-c,bbtest3bdprms
    if ($F2 eq "DBS_FULL_LOGGING_NO_TLOG_BACKUP:")
    {
      $ev_cat = "Bkup";
      &event("W",$thishost,"Found $F3 Database(s) in Full/Bulk-Logged Recovery Model with no TLOG backups (last 30 days) - DBs: $F4","DBsNoTLOGBkups","DBA519");
      next;
    }
     
    if ($F2 eq "BACKUPJOB:" && $mssql_backup_job_logic)
    {
      chop($evalstmt = substr($F0,27)); 
      $evalstmt =~ s/\\\\\$/\\\$/g;
      ##$evalstmt =~ s/'/\\'/g;
      eval $evalstmt;

      if ($@)
      {
	##print "evalstmt=$evalstmt";
	##print "evalout=$@\n"; 
        next;
      }

      ##print "jobname=$jobname jobcmd=$jobcmd\n";

      $statement  = "
	insert into dbamon.mssql_backup_jobs
	  (server,jobname,jobcmd,jobtype)
	values
	  (\'$fqhostname[$h]\', \'$jobname\', \'$jobcmd\', \'$jobtype\')
      ";

      &runSQL($statement,1);
      ##print "statement=$statement sqlerror=$sqlerror sqlcode=$sqlcode\n" if $sqlerror && $sqlerror !~ /unique constraint/;
    }

    #---- Backup age (TLOG) data
    if ($F1 eq "BckAgeTLOG:")
    {
      $sqlBkupTLogStack[$thishost] .= $F0; 
      next;
    }

    #---- Backup method (from alternate sql method)
    if ($F2 eq "Backup_Method:")
    {
      $backup_method_alternate = $F3; 
      next;
    }

    #---- Backup method (from alternate sql method)
    #       dbamon_mssql.pl BckAgeFullDays: bbtest1[BLANK]a[BLANK]b 0 2012/08/28-20:30:24.000
    if ($F2 eq "BckAgeFullDays:")
    {
      my $bckage_full_db   = $F3; 
      my $bckage_full_days = $F4; 
      my $bckage_full_ts   = $F5; 
      my $zcolor = "white"; 
      my $zmsg   = ""; 
      &metricsInsert ("sqlBkup()", $thishost, "BCKAGE_FULL_DAYS", $bckage_full_db, $bckage_full_days);
      &metricsCurrent("sqlBkup()", $thishost, "BCKAGE_FULL_DAYS", $bckage_full_db, $bckage_full_days, "", $backup_age_full[$thishost],
        "Days since last good FULL DB Backup for this DB: $bckage_full_days");
      if ($bckage_full_days > 0 && 
          $backup_age_full[$thishost] > 0 && 
          $bckage_full_days >= $backup_age_full[$thishost] &&
          &sqlBkup_DBCheck($bckage_full_db) == 1) 
      {
        #---- Old
        ##$ev_cat = "Bkup";
        ##&event("C",$thishost,"$bckage_full_days Days Since Last Good Full DB Backup For DB=$bckage_full_db - Threshold=$backup_age_full[$thishost] days","BkpFullAge","DBA813");
        #---- New
        $bck_full_events .= "DB=$bckage_full_db  Days Since Last Good Full DB Backup=$bckage_full_days  Threshold=$backup_age_full[$thishost] (days)\n"; 
        $zcolor = "pink"; 
        $zmsg = "<b>Critical - $bckage_full_days Days Since Last Good Full DB Backup For DB=$bckage_full_db - Threshold=$backup_age_full[$thishost] days</b>";
      }
      else
      {
        if ($backup_age_full[$thishost] > 0) 
        {
          $zcolor = "lightgreen"; 
          $zmsg = "OK -or- This DB was excluded from DB Backup Checking";
        }
        else
        {
          $zcolor = "white"; 
          $zmsg = "Backup_Age_Full_Days: DBC Parm Was not specified"; 
        }
      }

      #---- Create report line
      $bckdays_report .= "<tr bgcolor=$zcolor> 
        <td>$f_s <b>$bckage_full_db </b>
        <td>$f_s $bckage_full_ts
        <td align=right>$f_s $bckage_full_days
        <td>$f_s $zmsg
      "; 
      next;
    }

    #---- Backup age data
    if ($F1 eq "BckAge:")
    {
      $db      = $F2;
      $age     = $F3;
      $lstdate = $F4;
      $lsttime = $F5;
      $lstmeth = $F6 if $F6;

      ($lstts = $lstdate) =~ s/\-/\//g;
      $lstts .= '-' . substr($lsttime,0,8);
      $maxts = $lstts if $lstts > $maxts;

      if (
          lc $db eq "tempdb" || 
          lc $db eq "model" || 
          lc $db eq "northwind" || 
          lc $db eq "pubs" 
         )
      {
        &logit("Backup Not Applicable - Special DB=$db",$thishost);
	&logDetails($thishost,"<tr bgcolor=$table_rowcolor>
	  <td>$f_s <b> $db </b> 
	  <td align=right>$f_s &nbsp; 
	  <td align=right>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s Backup N/A - Special DB");
        next;
      }

      $db_lc = lc $db; 
      ##print "db=$db db_lc=$db_lc lm=$lstmeth lstts=$lstts maxts=$maxts db_attrs=$db_attrs[$thishost]{$db_lc}\n";

      if ($db_attrs[$thishost]{$db} =~ /Snapshot/)
      {
        &logit("Backup Not Applicable - Snapshot DB=$db",$thishost);
	&logDetails($thishost,"<tr bgcolor=$table_rowcolor>
	  <td>$f_s <b> $db </b> 
	  <td align=right>$f_s &nbsp; 
	  <td align=right>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s Backup N/A - Snapshot DB");
        next;
      }

      if ($db_attrs[$thishost]{$db} =~ /=restoring,/i)
      {
        &logit("Backup Not Applicable - DB=$db is RESTORING",$thishost);
	&logDetails($thishost,"<tr bgcolor=$table_rowcolor>
	  <td>$f_s <b> $db </b> 
	  <td align=right>$f_s &nbsp; 
	  <td align=right>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s Backup N/A - DB is Restoring");
        next;
      }

      if ($db_attrs[$thishost]{$db} =~ /=offline,/i)
      {
        &logit("Backup Not Applicable - DB=$db is OFFLINE",$thishost);
	&logDetails($thishost,"<tr bgcolor=$table_rowcolor>
	  <td>$f_s <b> $db </b> 
	  <td align=right>$f_s &nbsp; 
	  <td align=right>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s Backup N/A - DB is Offline");
        next;
      }

      #---- 2012/06/02 BB: If DB is specified in NOCHECK, then stop
      $dbchk = lc ",$db,";
      if  (index($backup_nocheck_dbs[$thishost], $dbchk) > -1)
      {
        &logit("Backup Check Not being performed - DB=$db is found in Backup_NoCheck_DBs: ($backup_nocheck_dbs[$thishost])",$thishost);
	&logDetails($thishost,"<tr bgcolor=$table_rowcolor>
	  <td>$f_s <b> $db </b> 
	  <td align=right>$f_s &nbsp; 
	  <td align=right>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s &nbsp; 
	  <td>$f_s Backup N/A - DB is specified in Backup_NoCheck_DBs: DBC Parm");
        next;
      }

      $zd = $lstdate;
      $zd =~ s/-/\//g;
      $zt = substr($lsttime,0,8);
      $zts = "$zd-$zt";
      $zts = "(Never)" if $zts eq "-";

      if ($delflag == 0) 
      {
	# Delete old data for this server
	$sqlstmt = "delete from dbamon.mssql_backup where server = '$titleraw[$thishost]'";
	&runSQL($sqlstmt);
        $delflag = 1;
      }

      # insert a new row for this db;
      $sqltext  = "insert into dbamon.mssql_backup (dbamonmode,server,db,bkage,bkts,dbcfile) \n";

      $age = -1 if $age eq "";

      $sqltext .= "values ('$modeout', 
			     '$titleraw[$thishost]',
			     '$db',
			     '$age', 
			     '$zts',
			     '$dbcfile[$thishost]'
			     )";
      &runSQL($sqltext);
      ##print "inserted $sqltext\n";

      next if $backup_age[$thishost] eq "";

      # Just in case we exceed, set these vars and make report
      $rounded1 = int($age / 10);
      $rounded1 = $rounded1 * 10;
      $rounded2 = $rounded1 + 9;

      #---- Save this for later  
      if ($age > $max_age)
      {
        $max_age = $age; 
        $max_range = "${rounded1}-${rounded2}";
      }

      $dbchk = ",$db,";
      print "-- found db=$db age=$age bat=$backup_age[$thishost] bcd=$backup_dbs[$thishost] dbchk=$dbchk\n" if $debug_22;

      $bck_msg = "This DB was not specified in Backup_Check_DBs: DBC Parm"; 

      $rerun = 0;
      $bcksev = "C";
      $bckcolor = "white";
      $bckrerun_msg = "";

      #---- Not needed any more - We now group the backup events
      # open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
      # print TMPFL6 "---------------------------------------------------\n";
      # print TMPFL6 "Most recent successful D/I backup of database: $db\n";
      # print TMPFL6 "Date: $lstdate \n";
      # print TMPFL6 "Time: $lsttime \n";
      # print TMPFL6 "---------------------------------------------------\n";
      # print TMPFL6 "\nAll Registered Backups For Database: $db \n"; 
      # print TMPFL6 "<table border=0> \n ";
      # print TMPFL6 "<tr bgcolor=$table_headbgcolor><th>$f_s Database Name<th>$f_s Backup Timestamp<th>$f_s Backup Type<th>$f_s Age (Hours)</tr>\n";
      # ##print "cat $probeout_file[$thishost] | grep '<tr' | grep '$db' \n";
      # ##system("cat $probeout_file[$thishost] | grep '<tr' | grep '$db' ");
      # print TMPFL6 `cat $probeout_file[$thishost] | grep '<td>$db '`;
      # print TMPFL6 "</table> \n";
      # close(TMPFL6);

      #---- OLD - 5.30  
      #if (index($backup_dbs[$thishost],lc $dbchk) > -1 || $db eq "master" || $db eq "msdb" || $backup_dbs[$thishost] eq ",all,")
      #---- NEW - 5.30 - Now we will check all for ALL DBs by default
      if  (index($backup_dbs[$thishost],lc $dbchk) > -1 || $db eq "master" || $db eq "msdb" || $backup_dbs[$thishost] eq ",all," || $backup_dbs[$thishost] eq "")
      {
        if ($age > $finalage) { $finalage = $age; }

        # Determine whether to try a rerun 

	print "  DB HIT #1 db=$db dbchk=$cbchk iter_count=$iter_count backup_rerun_iter[$thishost]=$backup_rerun_iter[$thishost]\n" if $debug_22;
	print "  DB HIT #2 age=$age backup_age[$thishost]=$backup_age[$thishost]\n" if $debug_22;

	if (
             ($age == -1 || $age > $backup_age[$thishost]) && 
              $backup_command[$thishost] ne "" && 
              $backup_rerun_iter[$thishost] != ($iter_count - 1))
	{
	  # Issue rerun
	  # Async or foreground
	  ##print "su=$system_used[$thishost] ss=$system_size[$thishost] \n";

	  if ($system_used[$thishost] > 0.1) { $amethod = "B"; }
	  else                               { $amethod = "F"; }
	  
	  $cmd = "$perlpath[$thishost] $probe[$thishost] bkrun $db $amethod \"$backup_command[$thishost]\"";
	  print "  MSSQL backup rerun $title[$thishost] cmd=$cmd \n" if $debug_22;
	  remsh($cmd,$tmpfl4,$thishost);

          if ($debug_22)
          {
	    print "DEBUG: tmpf4: \n";
            system("cat $tmpfl4 | dbamon_mailer -s 'DBAmon sqlBkup() $titleraw[$thishost] Backup Rerun $db' $debug_email");

	    print "DEBUG: End\n";
          }

	  $backup_rerun_iter[$thishost] = $iter_count;

          # Log the restart
          $zdate = &getdate;
          system("echo '$zdate $dbms[$thishost] $titleraw[$thishost] $db cmd=$cmd' >> /opt/dbamon/dat/history/backup_rerun.dat");

          # See if an error occured running command
          if (system("grep 'ERROR:' $tmpfl4") == 0)
          {
            $ev_cat = "Bkup";
            &event("C",$thishost,"MSSQL DB=$db - Invoked Backup Failed - Method=$amethod","BkpFail","DBA515",$tmpfl4);
            $bcksev = "C";
	    $bckcolor = "lightpink";
	    $bckrerun_msg = "(Backup Rerun Failed)";
          }
          else
          {
            $ev_cat = "Bkup";
            &event("W",$thishost,"MSSQL DB=$db - Backup Was Invoked - Method=$amethod","BkpRerun","DBA514",$tmpfl4);
            $bcksev = "W";
	    $bckcolor = "yellow";
	    $bckrerun_msg = "(Backup Rerun Was Attempted)";
            $rerun = 1;
          }
        }

        #---- Why is this here? 
        ##$bckhours_c[$thishost] = $bckcolor;

        &metricsCurrent("sqlBkup()",$thishost,"BACKUP_AGE_DB",$db,$age,"",$backup_age[$thishost],"Hours since last good DB Backup for this DB: $age");

        #if ($age == -1)
        if ($age == -999999)
        {
          $ev_cat = "Bkup";
          &event($bcksev,$thishost,"MSSQL DB=$db - Backup Never Run - Threshold=$backup_age[$thishost] $bckrerun_msg","BkpNever-DB","DBA810$bcksev");
          $bck_msg = "$f_s <b>Critical Event - No Backup Ever</b>";
	}
        elsif ($age > $backup_age[$thishost])
        {
          #---- Cache this 811 event
          $z = sprintf("DB: %-20s - Hours since last good backup: %4d - Rerun status: $bckrerun_msg\n",$db,$age);
          $events_811{"$bcksev-$rounded1-$rounded2"} .= $z; 
          $alltext_811                               .= $z; 
          $bckcolor = "pink";
          $bckhours_c[$thishost] = $bckcolor;
          $bck_msg = "$f_s <b>Event - Backup Age Threshold of $backup_age[$thishost] Exceeded</b>"
	}
        else
        {
	  &logit("OK - DB=$db Age=$age Threshold=$thishost",$thishost);
          $bckcolor = "lightgreen";
          $bck_msg = "$f_s <b>OK - Backup Age Threshold of $backup_age[$thishost] NOT Exceeded</b>"
        }
      }

      #if ($age == -1) { $zage = "<b>(Never)</b>"; }
      if ($age == -999999) { $zage = "<b>(Never)</b>"; }
      else            { $zage = $age; }
      &logDetails($thishost,"<tr bgcolor=$bckcolor>
        <td>$f_s <b> $db </b> 
        <td align=right>$f_s $backup_age[$thishost]
        <td align=right>$f_s $zage
        <td>$f_s $lstdate $f_s $lsttime
        <td>$f_s $bck_days_since_full{$db}  &nbsp; 
        <td>$f_s $bck_msg"
      );
      ## $bck_days_since_full{$bckage_full_db} = $bckage_full_days; 

      #---- Pointless 
      ## &histCreate("sqlBkup()",$thishost,"BCKAGE_D",$db,$age,$backup_age[$thishost]);

      &metricsInsert("sqlBkup()",$thishost,"BCKAGE_D",$db,$age);
    }
  }
  close(PROBEOUT);

  &logDetails($thishost,"</table>");

  &logDetails($thishost,"<h3>MSSQL Database Backup Details</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Database<br>Name
    <th>$f_s Backup Type
    <th>$f_s Most Recent<br>Backup Timestamp<br>Of This<br>Backup Type
    <th>$f_s Age of This Backup<br>(Hours)
    <th>$f_s Age of This Backup<br>(Days)
  ");
  ##&logDetails($thishost,$backup_details[$thishost]);
  &logDetails($thishost,$backup_details);
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>MSSQL Database FULL DB Backup Summary</h3>");
  &logDetails($thishost,"$f_s DBC Parm: Backup_Age_Full_Days: $backup_age_full[$thishost] <p>"); 
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Database<br>Name
    <th>$f_s Most Recent<br>Full DB Backup Timestamp
    <th>$f_s Age of This Backup<br>(Days)
    <th>$f_s Status Message 
  ");
  &logDetails($thishost,$bckdays_report);
  &logDetails($thishost,"</table><hr>");
  

  $bckhours[$thishost] = $finalage;
  if ($bckhours[$thishost] == -1) { $bckhours[$thishost] = "(Never)" }

  print "sqlBkup - $titleraw[$thishost] lstmeth=[$lstmeth]\n" if $debug_22;

  #---- 2012/01/31 BB 5.29
  ##if ($lstmeth eq "UN" && $backup_method_alternate ne "") { $lstmeth = $backup_method_alternate; } 
  #---- 2012/04/17 BB 5.32
  if ($backup_method_alternate ne "") { $lstmeth = $backup_method_alternate; } 

  if    ($lstmeth eq "D" ) { $backup_method_long[$thishost] = "bkDISK"; }
  elsif ($lstmeth eq "V" ) { $backup_method_long[$thishost] = "bkVERITAS"; }
  elsif ($lstmeth eq "OB") { $backup_method_long[$thishost] = "bkOMNIBACK"; }
  elsif ($lstmeth eq "UN") { $backup_method_long[$thishost] = "bkUnknown"; }
  elsif ($lstmeth eq "CV") { $backup_method_long[$thishost] = "bkCommVault"; }
  elsif ($lstmeth eq "RG") { $backup_method_long[$thishost] = "bkRedGate"; }
  elsif ($lstmeth eq "SY") { $backup_method_long[$thishost] = "bkSymantec"; }
  else                     { $backup_method_long[$thishost] = "bk$lstmeth"; }

  $mr_backup_date[$thishost] = $maxts; 

  #---- Create events for any cached 811's

  undef %posted_811;
  
  foreach (sort keys %events_811)
  {
    $key   = $_;
    $sev   = substr($key,0,1); 
    $range = substr($key,2); 
    $text  = $events_811{"$key"};

    $range_lower    = (split(/\-/,$key)) [1];
    $range_pct_of_t = int($range_lower / $backup_age[$thishost]) * 100 if $backup_age[$thishost] > 0;
    if ($range_pct_of_t > 200)
    {
      $this_pri = "H"; 
    }
    else
    {
      $this_pri = undef;
    }

    ##print "DEBUG - Event: 811 - key=$key sev=$sev range_lower=$range_lower range_pct_of_t=$range_pct_of_t t=$backup_age[$thishost] this_pri=$this_pri\n";

    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n\n";
    print TMPFL2 "------- Report of Databases Which Needed To Be Backed Up -------\n\n";
    print TMPFL2 "$alltext_811\n";
    print TMPFL2 "$dashes\n\n";

    #---- No good reason to include probe raw data - we need to do this LESS
    # print TMPFL2 "------- Probe Raw Data -------\n\n";
    # #---- Old
    # ###print TMPFL2 $z; `cat $probeout_file[$thishost]`;
    # #---- New
    # print TMPFL2 &fileReadScalar($probeout_file[$thishost]); 

    close(TMPFL2);

    if (! $posted_811{$sev}) 
    {
      $ev_cat = "Bkup";
      &event($sev,$thishost,"More than $backup_age[$thishost] Hours Since Last Good Full/Differential DB Backup for at least 1 DB (Threshold: $backup_age[$thishost] hours)","BkpAge-DB","DBA811",$tmpfl2,undef,undef,$this_pri);
      $bckhours_c[$thishost] = "lightpink";
    }
    $posted_811{$sev} = 1;
  }

  ##print "lm=$lstmeth bml=$backup_method_long[$thishost]\n";
  ##print "DEBUG - sqlBkup - bckhours_c[$thishost]=$bckhours_c[$thishost]\n";

  #---- See if there are any FULL backup events to process
  if ($bck_full_events ne "") 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n\n";
    print TMPFL2 "------- Report of Databases Which Need a FULL Backup -------\n\n";
    print TMPFL2 "$bck_full_events\n";
    print TMPFL2 "$dashes\n\n";
    close(TMPFL2);

    $ev_cat = "Bkup";
    &event("C",$thishost,"More than $backup_age_full[$thishost] Days Since Last Good Full DB Backup For at least 1 DB","BkpFullAge","DBA813", $tmpfl2);
  }

  #---- Process possible OK message in instance log
  if ($short eq "")
  {
    $msg = sprintf("OK (%s/%s) bckhours_c=$bckhourc_c[$thishost]",$finalage,$backup_age[$thishost]);
    &logit($msg,$thishost);
  }

  #---- Userexit
  if (-x "/opt/dbamon/bin/userexit/inc_sqlbkup")
  {
    if (! $inc_userexit)
    {
      #---- Moved to main
      ##push(@INC,"/opt/dbamon/bin/userexit");
      $inc_userexit = 1;
    }
    require "inc_sqlbkup";
    &inc_sqlbkup;
  }

  #---- Save these for the summarize routine
  $bckhours_color_db[$thishost] = $bckhours_c[$thishost];
  $bckhours_value_db[$thishost] = $bckhours[$thishost]; 

}
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
sub sqlBkup_DBCheck
# -----------------------------------------------------------------------------
{
  my $thisdb     = $_[0]; 
  my $return_val = -1; 

  #---- Prepare for comparison
  $thisdb = lc ",$thisdb,";

  &logit("sqlBkup_DBCheck Starting - thisdb=$thisdb",$thishost);

  #---- FAIL this DB by default
  $return_val = 0; 

  #---- If ANY of these are true, then proceed
  if  (index($backup_dbs[$thishost], $thisdb) > -1 || 
       $db eq "master" || 
       $db eq "msdb"   || 
       $backup_dbs[$thishost] eq ",all," || 
       $backup_dbs[$thishost] eq "") 
  {
    #---- So we are going to PASS this DB, UNLESS it is in this list 
    if (index($backup_nocheck_dbs[$thishost], $thisdb) == -1)
    {
      #---- It was NOT found in the NOCHECK LIST, so we will PASS this DB
      $return_val = 1; 
    }
  }

  &logit("sqlBkup_DBCheck Done - Returning return_val=$return_val",$thishost);
  return $return_val; 
}
# -----------------------------------------------------------------------------

1;
